// replace.cpp -- A util to replace the gb2312 part of gbk font with
//              gb2312 encoded font
// Su Yong <ysu@gnocis.org> Jun 6 2001
// It's a public domain software.

// Usage: ./replace gbk24font gb24st.bdf > newfont.bdf
// Remark: You can find gb24st.bdf in the source of XFree86.

#include <iostream>
#include <fstream>
#include <strstream>
#include <string>
#include <stdlib.h>
#include <cstdio>
#include "replace.h"

int main(int argc, char* argv[])
{
    ifstream is(argv[1]);
    
    if (!is)  // open file fail
        exit(1);

    CHAR_list_t char_list;
    char line[1024];
    while (!is.eof())
    {
        is.getline(line, 1024);
        string line_str(line);
        if (line_str.find("STARTCHAR") == 0)
        {
            CHAR ch;
            int code;
            ostrstream text;
            sscanf(&line[10], "%x", &code);
            code += 0x8080;
            ch.code = code;
            text << "STARTCHAR 0x" << hex << code << endl
                 << "ENCODING " << dec << code << endl;
            is.getline(line, 1024); // skip one line
            while (1)
            {
                is.getline(line, 1024);
                string line_str(line);
                if (line_str.find("ENDCHAR") == 0)
                {
                    text << line << endl << ends;
                    break;
                }
                else
                {
                    text << line << endl;
                }
            }
            ch.text = text.str();
            char_list.push_back(ch);
            //  cout << code << endl;
        }
    }
    
    ifstream is1(argv[2]);
    if (!is1)
        exit(1);

    while (!is1.eof())
    {
        is1.getline(line, 1024);
        string line_str(line);
        if (line_str.find("STARTCHAR") == 0)
        {
            int code;
            sscanf(&line[10], "%x", &code);
            int index = search(char_list, code);
            if (index >= 0)
            {
                cout << char_list[index].text;
                char_list.erase(char_list.begin() + index);
                is1.getline(line, 1024); // skip one line
                while (1)
                {
                    is1.getline(line, 1024);
                    string line_str(line);
                    if (line_str.find("ENDCHAR") == 0)
                        break;
                }
            }
            else
            {
                cout << line << endl;
                while (1)
                {
                    is1.getline(line, 1024);
                    cout << line << endl;
                    string line_str(line);
                    if (line_str.find("ENDCHAR") == 0)
                        break;
                }
            }
        }
        else
            cout << line << endl;
    }
    
}

// return index in cl
int search(CHAR_list_t& cl, int code)
{
    int i, len = cl.size();
    for (i = 0; i < len; i++)
    {
        //        cout << i << endl;
        if (cl[i].code == code)
            return i;
    }
    return -1; // not in list
}

/*
  Local Variables:
  compile-command:"c++ replace.cpp -o replace"
  End:
*/
